//+------------------------------------------------------------------+
//|                                               ForecastSample.mq4 |
//|                                                           Candid |
//|                                                   likh@yandex.ru |
//+------------------------------------------------------------------+
#property copyright "Candid"
#property link      "likh@yandex.ru"

#property indicator_chart_window
//---- input parameters
extern int       EMAPeriod=55;
extern int       Horizon=50;

bool FirstPass;
double PR,mPR;
int FBar;
int pos;

double Buf[];
//+------------------------------------------------------------------+
//| Custom indicator initialization function                         |
//+------------------------------------------------------------------+
int init() {
//---- indicators

  SetIndexShift(0,Horizon);
   
  SetIndexBuffer(0,Buf);
  SetIndexStyle(0,DRAW_LINE,EMPTY,2);

  FirstPass = true;
//----
  return(0);
}
//+------------------------------------------------------------------+
//| Custom indicator deinitialization function                       |
//+------------------------------------------------------------------+
int deinit() {
//----
   
//----
  return(0);
}
//+------------------------------------------------------------------+
//| Custom indicator iteration function                              |
//+------------------------------------------------------------------+
int start() {
  if (FirstPass) {
    FirstPass = false;
    PR = 2.0/(EMAPeriod+1);
    mPR = 1-PR;
    FBar = Bars-Horizon-1;
    Buf[FBar+Horizon] = Close[FBar];
  }
  int counted_bars=IndicatorCounted();
  FBar = Bars-counted_bars-1;
  if (FBar > 1) FBar = Bars-Horizon-2;
  for (pos=FBar; pos >= -Horizon; pos--) {
    if (pos >= 0) Buf[pos+Horizon] = Close[pos]*PR + Buf[pos+Horizon+1]*mPR;
    else Buf[pos+Horizon] = Buf[pos+Horizon+1]+Point;
  }
//----
   
//----
  return(0);
}
//+------------------------------------------------------------------+